Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/AGRIF_DEMO/EXPREF/1_namelist_cfg
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/AGRIF_DEMO/EXPREF/1_namelist_cfg	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/AGRIF_DEMO/EXPREF/1_namelist_cfg	(revision 10001)
@@ -23,5 +23,5 @@
    nn_it000    =       1   !  first time step
    nn_itend    =      75   !  last  time step (std 5475)
-   nn_istate   =       0   !  output the initial state (1) or not (0)
+   ln_istate   = .false.   !  output the initial state
 /
 !-----------------------------------------------------------------------
Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/AGRIF_DEMO/EXPREF/2_namelist_cfg
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/AGRIF_DEMO/EXPREF/2_namelist_cfg	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/AGRIF_DEMO/EXPREF/2_namelist_cfg	(revision 10001)
@@ -23,5 +23,5 @@
    nn_it000    =    1      !  first time step
    nn_itend    =  300      !  last  time step
-   nn_istate   =      0    !  output the initial state (1) or not (0)
+   ln_istate   = .false.   !  output the initial state
    ln_clobber  = .true.    !  clobber (overwrite) an existing file
 /
Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/AGRIF_DEMO/EXPREF/3_namelist_cfg
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/AGRIF_DEMO/EXPREF/3_namelist_cfg	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/AGRIF_DEMO/EXPREF/3_namelist_cfg	(revision 10001)
@@ -23,5 +23,5 @@
    nn_it000    =    1      !  first time step
    nn_itend    =  900      !  last  time step
-   nn_istate   =      0    !  output the initial state (1) or not (0)
+   ln_istate   = .false.   !  output the initial state
    ln_clobber  = .true.    !  clobber (overwrite) an existing file
 /
Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/AGRIF_DEMO/EXPREF/namelist_cfg
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/AGRIF_DEMO/EXPREF/namelist_cfg	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/AGRIF_DEMO/EXPREF/namelist_cfg	(revision 10001)
@@ -23,5 +23,5 @@
    nn_it000    =       1   !  first time step
    nn_itend    =      75   !  last  time step (std 5475)
-   nn_istate   =       0   !  output the initial state (1) or not (0)
+   ln_istate   = .false.   !  output the initial state
 /
 !-----------------------------------------------------------------------
Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/GYRE_BFM/EXPREF/namelist_cfg
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/GYRE_BFM/EXPREF/namelist_cfg	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/GYRE_BFM/EXPREF/namelist_cfg	(revision 10001)
@@ -26,5 +26,5 @@
    nn_stock    =    4320   !  frequency of creation of a restart file (modulo referenced to 1)
    nn_write    =      60   !  frequency of write in the output file   (modulo referenced to nn_it000)
-   nn_istate   =       0   !  output the initial state (1) or not (0)
+   ln_istate   = .false.   !  output the initial state
 /
 !-----------------------------------------------------------------------
Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/GYRE_PISCES/EXPREF/namelist_cfg
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/GYRE_PISCES/EXPREF/namelist_cfg	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/GYRE_PISCES/EXPREF/namelist_cfg	(revision 10001)
@@ -157,11 +157,11 @@
 &namdyn_adv    !   formulation of the momentum advection                (default: NO selection)
 !-----------------------------------------------------------------------
-   ln_dynadv_vec = .true.  !  vector form - 2nd centered scheme
-     nn_dynkeg     = 0        ! grad(KE) scheme: =0   C2  ;  =1   Hollingsworth correction
+   ln_dynadv_cen2= .true.  !  flux form - 2nd order centered scheme
+   ln_dynadv_ubs = .false. !  flux form - 3rd order UBS      scheme
 /
 !-----------------------------------------------------------------------
 &namdyn_vor    !   Vorticity / Coriolis scheme                          (default: NO selection)
 !-----------------------------------------------------------------------
-   ln_dynvor_ene = .true.  !  energy conserving scheme
+   ln_dynvor_enT = .true.  !  energy conserving scheme (T-point)
 /
 !-----------------------------------------------------------------------
Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/ORCA2_ICE_PISCES/EXPREF/namelist_cfg
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/ORCA2_ICE_PISCES/EXPREF/namelist_cfg	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/ORCA2_ICE_PISCES/EXPREF/namelist_cfg	(revision 10001)
@@ -23,5 +23,5 @@
    nn_it000    =       1   !  first time step
    nn_itend    =    5475   !  last  time step (std 5475)
-   nn_istate   =       0   !  output the initial state (1) or not (0)
+   ln_istate   = .false.   !  output the initial state
 /
 !-----------------------------------------------------------------------
@@ -295,12 +295,11 @@
 &namdyn_adv    !   formulation of the momentum advection                (default: NO selection)
 !-----------------------------------------------------------------------
-   ln_dynadv_vec = .true.  !  vector form - 2nd centered scheme
-     nn_dynkeg     = 0        ! grad(KE) scheme: =0   C2  ;  =1   Hollingsworth correction
+   ln_dynadv_cen2= .true.  !  flux form - 2nd order centered scheme
+   ln_dynadv_ubs = .false. !  flux form - 3rd order UBS      scheme
 /
 !-----------------------------------------------------------------------
 &namdyn_vor    !   Vorticity / Coriolis scheme                          (default: NO selection)
 !-----------------------------------------------------------------------
-   ln_dynvor_een = .true.  !  energy & enstrophy scheme
-      nn_een_e3f = 0          ! =0   e3f = mean masked e3t divided by 4
+   ln_dynvor_enT = .true.  !  energy conserving scheme (T-point)
 /
 !-----------------------------------------------------------------------
Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/SHARED/namelist_ref
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/SHARED/namelist_ref	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/cfgs/SHARED/namelist_ref	(revision 10001)
@@ -52,5 +52,5 @@
       cn_ocerst_outdir= "."         !  directory in which to write output ocean restarts
    ln_iscpl    = .false.   !  cavity evolution forcing or coupling to ice sheet model
-   nn_istate   =       0   !  output the initial state (1) or not (0)
+   ln_istate   = .false.   !  output the initial state
    ln_rst_list = .false.   !  output restarts at list of times using nn_stocklist (T) or at set frequency with nn_stock (F)
    nn_stock    =    5475   !  frequency of creation of a restart file (modulo referenced to 1)
@@ -67,9 +67,13 @@
 &namdom        !   time and space domain
 !-----------------------------------------------------------------------
+   ln_RK3      = .false.   !  3rd order Runge-Kutta time stepping scheme
+   ln_MLF      = .false.   !  Modified Leap-Frog    time stepping scheme
+      rn_atfp     =    0.1    !  asselin time filter parameter
+   !
+   rn_Dt       = 5760.     !  ocean time step (dynamics and T-S)
+   !
    ln_linssh   = .false.   !  =T  linear free surface  ==>>  model level are fixed in time
+   !
    rn_isfhmin  =    1.00   !  treshold [m] to discriminate grounding ice from floating ice
-   !
-   rn_Dt       = 5760.     !  time step for the dynamics and tracer
-   rn_atfp     =    0.1    !  asselin time filter parameter
    !
    ln_crs      = .false.   !  Logical switch for coarsening module      (T => fill namcrs)
Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/ICE/iceistate.F90
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/ICE/iceistate.F90	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/ICE/iceistate.F90	(revision 10001)
@@ -94,9 +94,9 @@
       REAL(wp) ::   zarg, zV, zconv, zdv, zfac
       INTEGER , DIMENSION(4)           ::   itest
-      REAL(wp), DIMENSION(jpi,jpj)     ::   z2d
       REAL(wp), DIMENSION(jpi,jpj)     ::   zswitch    ! ice indicator
       REAL(wp), DIMENSION(jpi,jpj)     ::   zht_i_ini, zat_i_ini, zvt_i_ini            !data from namelist or nc file
       REAL(wp), DIMENSION(jpi,jpj)     ::   zts_u_ini, zht_s_ini, zsm_i_ini, ztm_i_ini !data from namelist or nc file
       REAL(wp), DIMENSION(jpi,jpj,jpl) ::   zh_i_ini , za_i_ini                        !data by cattegories to fill
+      REAL(wp), DIMENSION(jpi,jpj)     ::   z_ssh_h0, zsshu, zsshv, zsshf
       !--------------------------------------------------------------------
 
@@ -413,47 +413,19 @@
       snwice_mass_b(:,:) = snwice_mass(:,:)
       !
-      IF( ln_ice_embd ) THEN            ! embedded sea-ice: deplete the initial ssh below sea-ice area
+      IF( ln_ice_embd ) THEN           ! embedded sea-ice: deplete the initial ssh below sea-ice area
          !
          sshn(:,:) = sshn(:,:) - snwice_mass(:,:) * r1_rho0
          sshb(:,:) = sshb(:,:) - snwice_mass(:,:) * r1_rho0
          !
-         IF( .NOT.ln_linssh ) THEN
-            !
-            WHERE( ht_0(:,:) > 0 )   ;   z2d(:,:) = 1._wp + sshn(:,:)*tmask(:,:,1) / ht_0(:,:)
-            ELSEWHERE                ;   z2d(:,:) = 1._wp   ;   END WHERE
-            !
-            DO jk = 1,jpkm1                     ! adjust initial vertical scale factors                
-               e3t_n(:,:,jk) = e3t_0(:,:,jk) * z2d(:,:)
-               e3t_b(:,:,jk) = e3t_n(:,:,jk)
-               e3t_a(:,:,jk) = e3t_n(:,:,jk)
-            END DO
-            !
-            ! Reconstruction of all vertical scale factors at now and before time-steps
-            ! =========================================================================
-            ! Horizontal scale factor interpolations
-            ! --------------------------------------
-            CALL dom_vvl_interpol( e3t_b(:,:,:), e3u_b(:,:,:), 'U' )
-            CALL dom_vvl_interpol( e3t_b(:,:,:), e3v_b(:,:,:), 'V' )
-            CALL dom_vvl_interpol( e3t_n(:,:,:), e3u_n(:,:,:), 'U' )
-            CALL dom_vvl_interpol( e3t_n(:,:,:), e3v_n(:,:,:), 'V' )
-            CALL dom_vvl_interpol( e3u_n(:,:,:), e3f_n(:,:,:), 'F' )
-            ! Vertical scale factor interpolations
-            ! ------------------------------------
-            CALL dom_vvl_interpol( e3t_n(:,:,:), e3w_n (:,:,:), 'W'  )
-            CALL dom_vvl_interpol( e3u_n(:,:,:), e3uw_n(:,:,:), 'UW' )
-            CALL dom_vvl_interpol( e3v_n(:,:,:), e3vw_n(:,:,:), 'VW' )
-            CALL dom_vvl_interpol( e3u_b(:,:,:), e3uw_b(:,:,:), 'UW' )
-            CALL dom_vvl_interpol( e3v_b(:,:,:), e3vw_b(:,:,:), 'VW' )
-            ! t- and w- points depth
-            ! ----------------------
-            !!gm not sure of that....
-            gdept_n(:,:,1) = 0.5_wp * e3w_n(:,:,1)
-            gdepw_n(:,:,1) = 0.0_wp
-            gde3w_n(:,:,1) = gdept_n(:,:,1) - sshn(:,:)
-            DO jk = 2, jpk
-               gdept_n(:,:,jk) = gdept_n(:,:,jk-1) + e3w_n(:,:,jk  )
-               gdepw_n(:,:,jk) = gdepw_n(:,:,jk-1) + e3t_n(:,:,jk-1)
-               gde3w_n(:,:,jk) = gdept_n(:,:,jk  ) - sshn (:,:)
-            END DO
+         IF( .NOT.ln_linssh ) THEN     ! modified the now and before vertical mesh and scale factors 
+            !
+            !                             !* BEFORE fields : 
+            CALL ssh2e3_before               ! set:      hu , hv , r1_hu, r1_hv 
+            !                                    !  e3t, e3w, e3u, e3uw, e3v, e3vw
+            !
+            !                             !* NOW fields : 
+            CALL ssh2e3_now                  ! set: ht , hu , hv , r1_hu, r1_hv
+            !                                !      e3t, e3w, e3u, e3uw, e3v, e3vw, e3f
+            !                                !      gdept_n, gdepw_n, gde3w_n
          ENDIF
       ENDIF
Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/ASM/asminc.F90
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/ASM/asminc.F90	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/ASM/asminc.F90	(revision 10001)
@@ -58,15 +58,18 @@
     LOGICAL, PUBLIC, PARAMETER :: lk_asminc = .FALSE.  !: No assimilation increments
 #endif
-   LOGICAL, PUBLIC :: ln_bkgwri     !: No output of the background state fields
-   LOGICAL, PUBLIC :: ln_asmiau     !: No applying forcing with an assimilation increment
-   LOGICAL, PUBLIC :: ln_asmdin     !: No direct initialization
-   LOGICAL, PUBLIC :: ln_trainc     !: No tracer (T and S) assimilation increments
-   LOGICAL, PUBLIC :: ln_dyninc     !: No dynamics (u and v) assimilation increments
-   LOGICAL, PUBLIC :: ln_sshinc     !: No sea surface height assimilation increment
-   LOGICAL, PUBLIC :: ln_seaiceinc  !: No sea ice concentration increment
-   LOGICAL, PUBLIC :: ln_salfix     !: Apply minimum salinity check
-   LOGICAL, PUBLIC :: ln_temnofreeze = .FALSE. !: Don't allow the temperature to drop below freezing
-   INTEGER, PUBLIC :: nn_divdmp     !: Apply divergence damping filter nn_divdmp times
-
+   LOGICAL, PUBLIC ::   ln_bkgwri     !: No output of the background state fields
+   LOGICAL, PUBLIC ::   ln_asmiau     !: No applying forcing with an assimilation increment
+   LOGICAL, PUBLIC ::   ln_asmdin     !: No direct initialization
+   LOGICAL, PUBLIC ::   ln_trainc     !: No tracer (T and S) assimilation increments
+   LOGICAL, PUBLIC ::   ln_dyninc     !: No dynamics (u and v) assimilation increments
+   LOGICAL, PUBLIC ::   ln_sshinc     !: No sea surface height assimilation increment
+   LOGICAL, PUBLIC ::   ln_seaiceinc  !: No sea ice concentration increment
+   LOGICAL, PUBLIC ::   ln_salfix     !: Apply minimum salinity check
+   LOGICAL, PUBLIC ::   ln_temnofreeze = .FALSE. !: Don't allow the temperature to drop below freezing
+   INTEGER, PUBLIC ::   nn_divdmp     !: Apply divergence damping filter nn_divdmp times
+
+   LOGICAL, PUBLIC ::   l_dynasm      !: flag derived from ln_asm... flags for calling 
+   LOGICAL, PUBLIC ::   l_traasm      !: dyn_asm_inc and tra_asm_inc routines in step.F90
+   
    REAL(wp), PUBLIC, DIMENSION(:,:,:), ALLOCATABLE ::   t_bkg   , s_bkg      !: Background temperature and salinity
    REAL(wp), PUBLIC, DIMENSION(:,:,:), ALLOCATABLE ::   u_bkg   , v_bkg      !: Background u- & v- velocity components
Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DIA/diawri.F90
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DIA/diawri.F90	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DIA/diawri.F90	(revision 10001)
@@ -118,7 +118,7 @@
       ! 
       ! Output the initial state and forcings
-      IF( ninist == 1 ) THEN                       
+      IF( ln_istate ) THEN                       
          CALL dia_wri_state( 'output.init', kt )
-         ninist = 0
+         ln_istate = .FALSE.
       ENDIF
 
@@ -444,7 +444,7 @@
       IF( ln_timing )   CALL timing_start('dia_wri')
       !
-      IF( ninist == 1 ) THEN     !==  Output the initial state and forcings  ==!
+      IF( ln_istate ) THEN     !==  Output the initial state and forcings  ==!
          CALL dia_wri_state( 'output.init', kt )
-         ninist = 0
+         ln_istate = .FALSE.
       ENDIF
       !
@@ -878,5 +878,5 @@
       !!
       !! ** Method  :   NetCDF files using ioipsl
-      !!      File 'output.init.nc'  is created if ninist = 1 (namelist)
+      !!      File 'output.init.nc'  is created if ln_istate = T (namelist)
       !!      File 'output.abort.nc' is created in case of abnormal job end
       !!----------------------------------------------------------------------
@@ -1029,5 +1029,5 @@
       CALL histclo( id_i )
 #if ! defined key_iomput
-      IF( ninist /= 1  ) THEN
+      IF( ln_istate  ) THEN
          CALL histclo( nid_T )
          CALL histclo( nid_U )
Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DOM/dom_oce.F90
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DOM/dom_oce.F90	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DOM/dom_oce.F90	(revision 10001)
@@ -30,9 +30,11 @@
    !! ----------------------------
    !                                   !!* Namelist namdom : time & space domain *
+   LOGICAL , PUBLIC ::   ln_RK3         !: 2rd order Runge-Kutta scheme 
+   LOGICAL , PUBLIC ::   ln_MLF         !: Modified Leap-Frog    scheme (Leclair & Madec OM2010)
+   REAL(wp), PUBLIC ::      rn_atfp        !: asselin time filter parameter
+   REAL(wp), PUBLIC ::   rn_Dt          !: time step for the dynamics and tracer (for both RK3 & MLF)
    LOGICAL , PUBLIC ::   ln_linssh      !: =T  linear free surface ==>> model level are fixed in time
    LOGICAL , PUBLIC ::   ln_meshmask    !: =T  create a mesh-mask file (mesh_mask.nc)
    REAL(wp), PUBLIC ::   rn_isfhmin     !: threshold to discriminate grounded ice to floating ice
-   REAL(wp), PUBLIC ::   rn_dt          !: time step for the dynamics and tracer
-   REAL(wp), PUBLIC ::   rn_atfp        !: asselin time filter parameter
    LOGICAL , PUBLIC ::   ln_1st_euler   !: =0 start with forward time step or not (=1)
    LOGICAL , PUBLIC ::   ln_iscpl       !: coupling with ice sheet
@@ -143,12 +145,15 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hu_0  ,    hu_b ,    hu_n ,    hu_a   !: u-depth              [m]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hv_0  ,    hv_b ,    hv_n ,    hv_a   !: v-depth              [m]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::           r1_hu_b , r1_hu_n , r1_hu_a   !: inverse of u-depth [1/m]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::           r1_hv_b , r1_hv_n , r1_hv_a   !: inverse of v-depth [1/m]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hf_0                                  !: v-depth              [m]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) :: r1_ht_0                                 !: inverse of u-depth [1/m]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) :: r1_hu_0 , r1_hu_b , r1_hu_n , r1_hu_a   !: inverse of u-depth [1/m]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) :: r1_hv_0 , r1_hv_b , r1_hv_n , r1_hv_a   !: inverse of v-depth [1/m]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) :: r1_hf_0                                 !: inverse of v-depth [1/m]
 
    INTEGER, PUBLIC ::   nla10              !: deepest    W level Above  ~10m (nlb10 - 1)
    INTEGER, PUBLIC ::   nlb10              !: shallowest W level Bellow ~10m (nla10 + 1) 
 
-   !! 1D reference  vertical coordinate
-   !! =-----------------====------
+   !! 1D reference vertical coordinate
+   !! ==------------------------------
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)   ::   gdept_1d, gdepw_1d !: reference depth of t- and w-points (m)
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)   ::   e3t_1d  , e3w_1d   !: reference vertical scale factors at T- and W-pts (m)
@@ -170,5 +175,5 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   risfdep                 !: Iceshelf draft                    (ISF)
 
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   ssmask, ssumask, ssvmask             !: surface mask at T-,U-, V- and F-pts
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   ssmask, ssumask, ssvmask, ssfmask    !: surface mask at T-,U-, V- and F-pts
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:), TARGET :: tmask, umask, vmask, fmask   !: land/ocean mask at T-, U-, V- and F-pts
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:), TARGET :: wmask, wumask, wvmask        !: land/ocean mask at WT-, WU- and WV-pts
@@ -265,9 +270,9 @@
          &      e3uw_n(jpi,jpj,jpk) , e3vw_n(jpi,jpj,jpk) ,     STAT=ierr(5) )                       
          !
-      ALLOCATE( ht_0(jpi,jpj) , hu_0(jpi,jpj) , hv_0(jpi,jpj) ,                                           &
-         &                      hu_b(jpi,jpj) , hv_b(jpi,jpj) , r1_hu_b(jpi,jpj) , r1_hv_b(jpi,jpj) ,     &
-         &      ht_n(jpi,jpj) , hu_n(jpi,jpj) , hv_n(jpi,jpj) , r1_hu_n(jpi,jpj) , r1_hv_n(jpi,jpj) ,     &
-         &                      hu_a(jpi,jpj) , hv_a(jpi,jpj) , r1_hu_a(jpi,jpj) , r1_hv_a(jpi,jpj) , STAT=ierr(6)  )
-         !
+      ALLOCATE( ht_0(jpi,jpj)    , hu_0(jpi,jpj)   , hv_0(jpi,jpj)    , hf_0(jpi,jpj)    ,                     &
+         &                         hu_b(jpi,jpj)   , hv_b(jpi,jpj)    , r1_hu_b(jpi,jpj) , r1_hv_b(jpi,jpj) ,  &
+         &      ht_n(jpi,jpj)    , hu_n(jpi,jpj)   , hv_n(jpi,jpj)    , r1_hu_n(jpi,jpj) , r1_hv_n(jpi,jpj) ,  &
+         &                         hu_a(jpi,jpj)   , hv_a(jpi,jpj)    , r1_hu_a(jpi,jpj) , r1_hv_a(jpi,jpj) ,  &
+         &      r1_ht_0(jpi,jpj) , r1_hu_0(jpi,jpj), r1_hv_0(jpi,jpj) , r1_hf_0(jpi,jpj) , STAT=ierr(6)  )
          !
       ALLOCATE( gdept_1d(jpk) , gdepw_1d(jpk) , e3t_1d(jpk) , e3w_1d(jpk) , STAT=ierr(7) )
